/*
 *  Sachen pirate games (Poker III, Mei Nu Quan)
 */


#include "mapinc.h"

#define mReg mapbyte1[0]
#define mPrg mapbyte1[1]
#define mChr mapbyte1[2]
#define mMir mapbyte1[3]
#define mTmp mapbyte2[0]

DECLFW(Mapper243_write)
{
        if( (A&0x4101) == 0x4100 ) {
                mReg = V;
        } else if( (A&0x4101) == 0x4101 ) {
                switch( mReg & 0x07 ) {
                        case 0:
                                mPrg = 0;
                                mChr = 3;
                                break;
                        case 2:
                                mTmp = ((V&0x01)<<3);
                     break;
                        case 4:
                             mChr = (mChr&0x06)|(V&0x03);
                                break;
                        case 5:
                                mPrg = V&0x01;
                                break;
                        case 6:
                             mChr = mTmp|(mChr&0x01)|((V&0x03)<<1);
                        break;
                        case 7:
                                mMir = V&0x01;
                                break;
                }

                ROM_BANK32( mPrg );
                VROM_BANK8( mChr );


                if( mMir ) {
                        MIRROR_SET( 1 );
                } else {
                        MIRROR_SET( 0 );
                }
        }
}

void Mapper243_init(void)
{

        ROM_BANK32( 0 );
        VROM_BANK8( 3 );

        MIRROR_SET(0);

        SetWriteHandler(0x4100, 0x4FFF, Mapper243_write);

        mReg = 0;
        mPrg = 0;
        mChr = 3;
        mMir = 0;
}




