#include "mapinc.h"

#define reg mapbyte1[0]
#define hibank mapbyte1[1]

void sync()
{
   setchr1(0x0000,(((hibank<<3)+mapbyte1[0])<<2)+0);
   setchr1(0x0400,(((hibank<<3)+mapbyte1[0])<<2)+1);
   setchr1(0x0800,(((hibank<<3)+mapbyte1[1])<<2)+2);
   setchr1(0x0c00,(((hibank<<3)+mapbyte1[1])<<2)+3);
   setchr1(0x1000,(((hibank<<3)+mapbyte1[2])<<2)+0);
   setchr1(0x1400,(((hibank<<3)+mapbyte1[2])<<2)+1);
   setchr1(0x1800,(((hibank<<3)+mapbyte1[3])<<2)+2);
   setchr1(0x1c00,(((hibank<<3)+mapbyte1[3])<<2)+3);
}

DECLFW(Mapper191_write)
{
  switch(A){
   case 0x4100: reg=V;break;
   case 0x4101:
        if(reg<4)
        {
           mapbyte1[reg]=V&7;
           sync();
        }
        else
         switch(reg) {
          case 4: hibank=V&7;
                  sync();
                  break;
          case 5: setprg32(0x8000,V&7); break;
          case 7: if(V^2)
                   MIRROR_SET(0);
                  else
                   MIRROR_SET(1);
       }
  }
}

void Mapper191_init(void)
{
  SetWriteHandler(0x4100,0x4101,Mapper191_write);
  setprg32(0x8000,0);
//  sync();
}

